import gc
import microcontroller
import soundstuff


class Globaldata():
    print("class Globaldata()")
    starttone = (262, 494, 523)  # °a Signal Nach dem Einschalten
    lockedtone = (659, 0)  # °b Tastensperre ein
    unlockedtone = (659, 659)  # °c Tastensperre aus
    battempty = ((100, 0.3), )  # °d Batterie leer
    battlow = ((600, 0.1, 0.1), (100, 0.1, 0.1), (100, 0.1, 0.1))  # °e Batteriestand niedrig
    batthalf = ((600, 0.1, 0.1), (630, 0.1, 0.1), (660, 0.1, 0.1), (100, 0.1, 0.1))  # °f Batterie Halb voll
    battfull = ((600, 0.1, 0.1), (630, 0.1, 0.1), (660, 0.1, 0.1), (680, 0.1, 0.1))  # °g Batterie voll
    battcharge = "1400-1700:1"  # °h Batterie wird geladen
    battdischarge = "1700-1400:1"
    resettone = (523, 494, 262)  # °j
    reloadstarttone = (262, )  # °k Keybindings laden starten
    reloaddonetone = (523, )  # °l Keybindings geladen
    showstarttone = (262, 262)  # °m Testmode Start = Tastendrücke werden nicht ausgeführt sonder ausgegeben
    showdonetone = (523, 523)  # °n Testmode beendet
    loadusernameerrortone = (262, 0.3), (262, 0.3), (262, 0.3)  # °o
    userpassworderrortone = (262, 262, 262, 494)  # °p Beim Passwort stimmt etwas nicht
    loaduserpassworderrortone = (262, 262, 262)  # °q Die Passwort-Datei ist nicht vorhanden
    connectedtone = ((262, 0.25), 880)  # °r
    disconnectedtone = ((880, 0.25), 262)  # °s
    fastrepeattone = (220, 0.06)  # °t
    keyclicktone = (100, 0.02)  # °u
    keyclick = False  # Tastenklick ist als Standard ausgeschaltet
    computerbraille = (400, 0.02) # v
    vollschriftbraille = (200, 0.02) # w
    macrocancelrecord = "400-100:1"  # °0 (40)
    macrorecord1 = "200:100|400:100"  # °1 (31)
    macrorecord2 = "200:100|400:200#2"  # °2 (32)
    macrostoprecord = "400:100|20:100"  # °3 (33)
    macroplayactive = "1900:20"  # °4 (34)
    playmacro = "262:100|524:100"  # °5 (35)
    playmacrostart = "1900:20"  # °6 (36) Hier erwarte ich, dass nach Eingabe des Makrobuchstabens dieses Signal abgespielt wird. Tatsächlich erfolgt Signal playmacro.
    storemacro = "262:100;377:100;394:150"  # °7 (37)
    storemacrodone = "262:100|331:100|393:100|524:150"  # °8 (38)



    keyrepeatthreshold1 = 1
    keyrepeatthreshold2 = 90
    keydelay1 = 0.25
    keydelay2 = 0.05
    maxmoddiff = 0.05

    deviceversion = "V49"
    devicename = "MyKey"
    deviceof = "von"
    deviceby = "by"
    devicemanufacturer = "BBTF"

    macros = [[]] * 27
    shownvm = True

    def loadfromfile(self):
        try:
            filename = "globals.txt"
            with open(filename, "r") as textfile:
                while True:
                    try:
                        line = textfile.readline()
                        if not line:
                            print()
                            break # if line is empty end of file is reached
                        line = line.strip()
                        if len(line) == 0:
                            continue
                        if line[0] == "#":
                            continue
                        line = "self." + line
                        print(line)
                        exec(line, {"self": self})
                    except Exception as e:
                        print("Error gl:", str(e), line)
        except Exception as e:
            print("Error rf:", str(e), filename)
            return

    def getany(self, x,y):
        kbconf = microcontroller.nvm[x:y]
        if kbconf < b"a" or kbconf > b"z":
            microcontroller.nvm[x:y] = b"a"
        return "\\" + microcontroller.nvm[x:y].decode() + "\\"

    def setany(self, x, y, c):
        if c < "a" or c > "z":
            return False
        microcontroller.nvm[x:y] = c.encode()
        return True

    def getkbi(self):
        return self.getany(90, 91)

    def setkbi(self, c):
        return self.setany(90, 91, c)

    def getkbc(self):
        return self.getany(91, 92)

    def setkbc(self, c):
        return self.setany(91, 92, c)

    def getkbl(self):
        return self.getany(92, 93)

    def setkbl(self, c):
        return self.setany(92, 93, c)

    def getpartnerid(self):
        r = "-all"
        nr = microcontroller.nvm[93:94][0]
        print("partner nr:", nr)
        while True:
            if nr == 9:
                r = "*"
                break
            if nr > 4:
                nr = microcontroller.nvm[93:94][0]
                print("set nr = 0!")
                nr = 0
                microcontroller.nvm[93:94] = bytes([nr])
            if nr == 0:
                break
            pos = 3500+(nr-1)*30
            ba = microcontroller.nvm[pos:pos+30]
            i = 0
            while True:
                if ba[i] == 0:
                    ba = ba[0:i]
                    r = ba.decode()
                    break
                i += 1
                if i >= 30:
                    break
            break
        if self.shownvm:
            self.shownvm = False
            print("getpartnerid:", r)
        return r

    def setpartnerid(self, nr, id):
        pos = 3500+(nr-1)*30
        print(" "*20, "setpartnerid", nr, pos, id)
        ba = str(id).encode()
        bar = bytearray(ba)
        bar.append(0)
        microcontroller.nvm[pos:pos + len(bar)] = bar
        print("nvm 3500-3600", microcontroller.nvm[3500:3600])
        return

    def setcurrentpartner(self, nr):
        self.shownvm = True
        microcontroller.nvm[93:94] = bytes([nr])

    def initmacros(self):
        print("initmacros")
        if microcontroller.nvm[100:102] != b"MM":
            print("need to init!")
            self.clearmacros()
            self.macros[0] = ["M", "y", "K", "e", "y"]
            self.savemacros()
        b = microcontroller.nvm[102:3500]
        i = 0
        while True:
            if b[i] == 0:
                # b = b[0:i]
                gc.collect()
                print("found 0 at:", i) # , b[0:i])
                s = b[0:i].decode()
                b = None
                gc.collect()
                # print("decoded:", s)
                try:
                    self.macros = eval(s)
                except Exception as e:
                    print("error", str(e))
                    self.clearmacros()
                print("final:", self.macros)
                while len(self.macros) > 26:
                    self.macros.pop(-1)
                if not isinstance(self.macros, list):
                    print("not a list 1")
                    self.clearmacros()
                if len(self.macros) != 26:
                    print("len(self.macros) != 26", len(self.macros))
                    self.clearmacros()
                mi = 0
                for m in self.macros:
                    mi += 1
                    if not isinstance(m, list):
                        print("not a list 2")
                        self.clearmacros()
                        break
                    print(mi, m)
                print("macros Type ok")
                break
            if i == 3400:
                gc.collect()
                self.clearmacros()
                print("end", i)
                gc.collect()
                break
            i += 1

        print("exit:", self.macros)
        pos = 3500
        print("nvm", pos, pos + 100, microcontroller.nvm[pos:pos + 100])

    def clearmacros(self):
        self.macros = [[]] * 27

    def savemacros(self):
        gc.collect()
        print("free", gc.mem_free())
        pos = 0
        microcontroller.nvm[102+pos:102+pos+1] = b"["
        pos = 1
        for i, macro in enumerate(self.macros):
            soundstuff.beep(262+10*i, 0.05)
            gc.collect()
            ba = str(macro).encode()
            print(i, gc.mem_free(), ba)
            microcontroller.nvm[102 + pos:102 + pos + len(ba)] = ba
            pos += len(ba)
            ba = None
            if i < 25:
                microcontroller.nvm[102 + pos:102 + pos + 1] = b","
                pos += 1

        microcontroller.nvm[102 + pos:102 + pos + 1] = b"]"
        pos += 1
        microcontroller.nvm[102 + pos:102 + pos + 1] = b"\x00"
        microcontroller.nvm[100:102] = b"MM"
        print(microcontroller.nvm[100:400])

# i = 1/0
globaldata = Globaldata()
globaldata.initmacros()
globaldata.loadfromfile()
